<template>
  <div>
    <div id="konva-container" @contextmenu="showContextMenu"></div>
    <!-- Custom context menu -->
    <div v-if="showCustomContextMenu" :style="{ top: contextMenuY + 'px', left: contextMenuX + 'px' }" class="custom-context-menu">
      <div :class="{ 'disabled-menu-item': isDotAP(selectedDotId) }" @click="testDot(selectedDotId); hideContextMenu()">
        Run Test
      </div>
      <div :class="{ 'disabled-menu-item': isDotTested(selectedDotId) }" @click="makeDotAp(selectedDotId); hideContextMenu()">
        Make AP
      </div>
      <div @click="removeDot(selectedDotId); hideContextMenu()">Delete Point</div>
    </div>
    <!-- Loading indicator or status message -->
    <div v-if="loading" class="overlay">
      <div class="loading-modal">
        <div class="loading-text">
          <div>Testing in progress</div>
          <div class="dots">{{ progressDots }}</div>
          <div>Point: {{ testX }}, {{ testY }}</div>
        </div>
      </div>
    </div>
  </div>
</template>

<style>
.custom-context-menu {
  position: absolute;
  background-color: white;
  border: 1px solid #ccc;
  padding: 5px;
  box-shadow: 2px 2px 4px rgba(0, 0, 0, 0.2);
}
.custom-context-menu div {
  cursor: pointer;
  padding: 5px;
  user-select: none;
}
.disabled-menu-item {
  cursor: not-allowed;
  opacity: 0.5;
}
.overlay {
  position: fixed;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  background-color: rgba(0, 0, 0, 0.5); /* Adjust the transparency here */
  z-index: 9999; /* Ensure it's on top of the canvas */
  pointer-events: auto; /* Block interactions with the canvas */
}

.loading-modal {
  position: fixed;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
  background: rgba(255, 255, 255, 0.9);
  padding: 20px;
  border-radius: 5px;
  text-align: center;
  width: 500px; /* Set a fixed width */
  margin-left: -100px; /* Half of the width for centering */
}

.loading-text {
  font-size: 18px;
  font-weight: bold;
  color: #333;
  margin-bottom: 10px; /* Add some space below the text */
}

.dots {
  font-size: 24px;
  animation: loadingDots 1s infinite;
}

@keyframes loadingDots {
  0% {
    content: '.';
  }
  33% {
    content: '..';
  }
  66% {
    content: '...';
  }
}
</style>

<script>
import axios from 'axios';
import Konva from 'konva';
import { v4 as uuidv4 } from 'uuid';

Konva.pixelRatio = 1;
Konva.imageSmoothingEnabled = false;

export default {
  data() {
    return {
      stage: null,
      layer: null,
      coordinates: [],
      showCustomContextMenu: false,
      contextMenuX: 0,
      contextMenuY: 0,
      selectedDotId: null,
      delta: 5,
      startX: 0,
      startY: 0,
      dragging: false,
      dots: [], // Store a reference to the dots
      loading: false,     // To track loading state
      testStatus: null,   // To track test status
      testX: null,
      testY: null,
      progressDots: '',
    };
  },

  async mounted() {
    try {
      // Make an API request to get the image size
      const imageSizeResponse = await axios.get(`http://127.0.0.1:5001/floorplan/size/${this.$route.params.project}`);
      console.log(imageSizeResponse.data);
      console.log(Konva.pixelRatio);
      const imageSize = imageSizeResponse.data;
      // Use the obtained image size to set the Konva Stage dimensions
      this.floorplanWidth = imageSize.x;
      this.floorplanHeight = imageSize.y;
      console.log("width:",this.floorplanWidth);
      console.log("height:",this.floorplanHeight);
      this.stage = new Konva.Stage({
        container: 'konva-container',
        width: this.floorplanWidth,
        height: this.floorplanHeight,
      });
  
      this.layer = new Konva.Layer();
  
      const backgroundImage = new Konva.Image({
        width: this.stage.width(),
        height: this.stage.height(),
      });
  
      const imageObj = new Image();
      const imageLoadPromise = new Promise((resolve, reject) => {
        imageObj.onload = resolve;
        imageObj.onerror = reject;
      });
      imageObj.src = (`http://127.0.0.1:5001/floorplan/${this.$route.params.project}`);
      await imageLoadPromise;
  
      backgroundImage.image(imageObj);
      this.layer.add(backgroundImage);
      this.stage.add(this.layer);
  
      await this.fetchDotsFromAPI();
      this.stage.draw();
    } catch (error) {
      console.error('Error loading image:', error);
    }    

    // Prevent the default context menu on the whole window
    window.addEventListener('contextmenu', (e) => {
      e.preventDefault();
    });

    this.stage.on('mousedown', (e) => {
      const pos = this.stage.getPointerPosition();
      this.startX = pos.x;
      this.startY = pos.y;
    });

    this.stage.on('mouseup', (e) => {
      const pos = this.stage.getPointerPosition();
      const diffX = Math.abs(pos.x - this.startX);
      const diffY = Math.abs(pos.y - this.startY);

      if (diffX < this.delta && diffY < this.delta) {
        if (e.evt.button === 0) { // 0 for left-click
          // Handle left-click here
          const x = pos.x;
          const y = pos.y;

          const dotId = uuidv4();
          this.createDot(x, y, dotId, false);
          this.coordinates.push({ id: dotId, x, y });
        } else if (e.evt.button === 2) { // 2 for right-click
          // Handle right-click here
          e.evt.preventDefault(); // Prevent the default context menu
          const pos = this.stage.getPointerPosition();
          this.contextMenuX = pos.x;
          this.contextMenuY = pos.y;
        }
      }
    });

    this.stage.draw();
  },

  methods: {
    createDot(x, y, dotId, tested, type='', newPoint = true) {

      let fillColor = 'gray';
      let drag = true;
      if (type == 'ap') {
        fillColor = 'blue';
        drag = false;
      }
      if (tested) {
        fillColor = 'green';
        drag = false;
      }
      const dot = new Konva.Circle({
        x,
        y,
        radius: 8, // Increase the radius to make the dots larger
        fill: fillColor,
        name: dotId,
        draggable: drag,
      });

      dot.on('dragend', (e) => {
        const newPosition = dot.position();

        // Make an API call to update the dot's position
        const path = `http://127.0.0.1:5001/point/${this.$route.params.project}/${dotId}`;
        let coords = new FormData();

        console.log("x:", newPosition.x, "y:", newPosition.y);
        coords.append('action', "move");
        coords.append('x', newPosition.x);
        coords.append('y', newPosition.y);

        axios.put(path, coords)
          .then(function (response) {
            console.log(response);
          })
          .catch(function (error) {
            console.log(error);
          });
          this.dragging = false;
      });

      this.stage.on('dragstart', (e) => {
        this.dragging = true;
      });

      // mouse up on dot
      dot.on('mouseup', (e) => {
        const pos = this.stage.getPointerPosition();
        const diffX = Math.abs(pos.x - this.startX);
        const diffY = Math.abs(pos.y - this.startY);

        if (e.evt.button === 2) {  // 2 for right-click detected
          e.evt.preventDefault();  // Prevent the default context menu
          this.showCustomContextMenu = true;
          this.contextMenuX = e.evt.clientX;
          this.contextMenuY = e.evt.clientY;
          this.selectedDotId = dotId;
        }
      });

      if (!this.dragging) {
        // Store a reference to the dot
        this.dots.push({ id: dotId, dot });

        this.layer.add(dot);
        this.stage.add(this.layer);

        if (newPoint) {
          const path = `http://127.0.0.1:5001/point/${this.$route.params.project}/${dotId}`;

          let coords = new FormData();

          coords.append('x', x);
          coords.append('y', y);
          console.log("x:", x, "y:",y);

          axios.post(path, coords)
          .then(function (response) {
            console.log(response);
          })
          .catch(function (error) {
            console.log(error);
          });
        }
      }
    },

    showContextMenu(e) {
      e.preventDefault(); // Prevent the default context menu
      return false; // Ensure the browser context menu doesn't appear
    },

    async testDot(dotId) {
      // Test the dot by its ID
      const dotObj = this.dots.find((dot) => dot.id === dotId);
      if (dotObj) {
        const dot = dotObj.dot;
        if (dot.fill() === 'blue') {
          console.log(`Point ${dotId} is an Access Point. Cannot run testing.`);
          return;
        }
        this.testX = dot.position().x;
        this.testY = dot.position().y;
        if (dot) {
          try {
            this.loading = true;
            this.pollTestStatus(dotId);
            this.coordinates = this.coordinates.filter((coord) => coord.id !== dotId);
            console.log(`Testing point with ID ${dotId}`);

            const path = `http://127.0.0.1:5001/test/point/${this.$route.params.project}/${dotId}`;
            console.log(path);
            await axios.get(path);
          } catch (error) {
            console.error(error);
            this.loading = false; // Set loading back to false when the test is complete
          }         
        }
      }
    },

    makeDotAp(dotId) {
      // Find and remove the dot by its ID
      const dotObj = this.dots.find((dot) => dot.id === dotId);
      if (dotObj) {
        const dot = dotObj.dot;
        if (dot.fill() === 'green') {
          console.log(`Point ${dotId} has been tested, it cannot become an AP.`);
          return;
        }
        if (dot) {
          const path = `http://127.0.0.1:5001/point/${this.$route.params.project}/${dotId}`;
          let data = new FormData();

          data.append('action', 'type');
          data.append('type', 'ap');

          axios.put(path, data)
            .then(function (response) {
              console.log(response);
              console.log(`point with ID ${dotId} converted to AP`);
              dot.fill('blue');
              dot.draggable(false);
            })
            .catch(function (error) {
              console.log(error);
            });
          this.stage.draw();
        }
      }
    },

    removeDot(dotId) {
      // Find and remove the dot by its ID
      const dotObj = this.dots.find((dot) => dot.id === dotId);
      if (dotObj) {
        const dot = dotObj.dot;
        if (dot) {
          dot.destroy();
          this.stage.draw();
          this.coordinates = this.coordinates.filter((coord) => coord.id !== dotId);
          const path = `http://127.0.0.1:5001/point/${this.$route.params.project}/${dotId}`;
          axios.delete(path)
            .then((res) => {
              console.log(`Deleted point with ID ${dotId}`);
            })
            .catch((error) => {
              console.error(error);
            });
        }
      }
    },

    async fetchDotsFromAPI() {
      try {
        const response = await axios.get(
          `http://127.0.0.1:5001/points/${this.$route.params.project}`);
        const points = response.data.list;

        points.forEach((point) => {
          console.log("x:", point.x, "y:", point.y);
          this.createDot(
            point.x,
            point.y,
            point.id,
            point.tested,
            point.type,
            false
          );
        });
        // Finally, draw the stage after all the dots are created.
        this.stage.draw();
      } catch (error) {
        console.error('Error fetching points:', error);
      }
    },

    async pollTestStatus(dotId) {
      const webhookURL = `http://127.0.0.1:5001/webhook/test/status/${this.$route.params.project}/${dotId}`;

      console.log(this.loading);
      console.log(this.testStatus);

      const waitFor = delay => 
        new Promise(resolve => 
          setTimeout(resolve, delay));
      await waitFor(500);
  
      while (this.loading) {
        try {
          if (this.progressDots === '.') {
            this.progressDots = '..'
          } else if (this.progressDots === '..') {
            this.progressDots = '...'
          } else if (this.progressDots === '...') {
            this.progressDots = '....'
          } else {
            this.progressDots = '.'
          }

          const response = await axios.get(webhookURL);
          this.testStatus = response.data.status;
          console.log(this.testStatus);

          if (this.testStatus === 'Test completed successfully') {
            const dotObj = this.dots.find((dot) => dot.id === dotId);
            if (dotObj) {
              const dot = dotObj.dot;
              dot.fill('green'); // Update dot color upon successful test
              dot.draggable(false);
              this.stage.draw();
            }
            this.loading = false;
          } else if (this.testStatus === 'Test failed') {
            const dotObj = this.dots.find((dot) => dot.id === dotId);
            if (dotObj) {
              const dot = dotObj.dot;
              dot.fill('red'); // Update dot color upon failed test
              dot.draggable(false);
              this.stage.draw();
            }
            this.loading = false;
          }
        } catch (error) {
          console.error('Error polling test status:', error);
          this.loading = false;
        }

        await new Promise(resolve => setTimeout(resolve, 1000)); // Adjust the polling interval as needed
      }
    },

    isDotAP(dotId) {
      const dotObj = this.dots.find((dot) => dot.id === dotId);
      return dotObj && dotObj.dot.fill() === 'blue';
    },

    isDotTested(dotId) {
      const dotObj = this.dots.find((dot) => dot.id === dotId);
      return dotObj && dotObj.dot.fill() === 'green';
    },

    hideContextMenu() {
      // Method to hide the custom context menu
      this.showCustomContextMenu = false;
    },
  },
};
</script>
